import { getSchedule, getScheduleWare, setSchedule, setScheduleWare } from '@/api/schoolTimetable'

const state = {
  getScheduleData: [],
  getScheduleDataLength: 0,
  getScheduleWareData: [],
  getScheduleWareDataLength: 0
}

const mutations = {
  GET_SCHEDULE: (state, data) => {
    state.getScheduleData = data
  },
  SCHEDUL_LENGTH: (state, length) => {
    state.getScheduleDataLength = length
  },
  GET_SCHEDULE_WARE: (state, data) => {
    console.log(data)
    state.getScheduleWareData = data
  },
  SCHEDULE_WARE_LENGTH: (state, length) => {
    state.getScheduleWareDataLength = length
  }
}

const actions = {
  // 获取课程表列表
  getScheduleList({ commit, state }, obj) {
    console.log(obj.page)
    return new Promise((resolve, reject) => {
      getSchedule({
        code: '',
        title: '',
        weekSeq: '',
        pageNo: obj.page
      }).then((res) => {
        const list = res.data.list
        const length = res.data.totalSize
        commit('SCHEDUL_LENGTH', length)
        commit('GET_SCHEDULE', list)
        resolve()
      }).catch(error => {
        reject(error)
      })
    })
  },
  // 获取课程表详情
  getScheduleWare({ commit, state }, obj) {
    const page = (obj.page - 1) * 10
    return new Promise((resolve, reject) => {
      getScheduleWare({
        scheduleId: obj.id
      }).then((res) => {
        const data = res.data
        commit('SCHEDULE_WARE_LENGTH', data.length)
        commit('GET_SCHEDULE_WARE', data.splice(page, 10))
        resolve()
      }).catch(error => {
        reject(error)
      })
    })
  },
  // 修改课程表
  setScheduleList({ commit, dispatch }, data) {
    return new Promise((resolve, reject) => {
      setSchedule(data).then((res) => {
        if (res.code === 200) {
          resolve()
        }
      }).catch(error => {
        reject(error)
      })
    })
  },
  // 修改课程表详情
  setScheduleWare({ commit, dispatch }, data) {
    return new Promise((resolve, reject) => {
      setScheduleWare(data).then((res) => {
        if (res.code === 200) {
          resolve()
        }
      }).catch(error => {
        reject(error)
      })
    })
  }
}

export default {
  namespaced: true,
  state,
  mutations,
  actions
}

